// src/devcenter-app-instance-v1-app-instance-app-instances.public.ts
import { renameKeysFromRESTResponseToSDKResponse as renameKeysFromRESTResponseToSDKResponse2 } from "@wix/sdk-runtime/rename-all-nested-keys";
import { transformRESTTimestampToSDKTimestamp as transformRESTTimestampToSDKTimestamp2 } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths as transformPaths2 } from "@wix/sdk-runtime/transformations/transform-paths";
import { EventDefinition } from "@wix/sdk-types";

// src/devcenter-app-instance-v1-app-instance-app-instances.universal.ts
import { transformError as sdkTransformError } from "@wix/sdk-runtime/transform-error";
import {
  renameKeysFromSDKRequestToRESTRequest,
  renameKeysFromRESTResponseToSDKResponse
} from "@wix/sdk-runtime/rename-all-nested-keys";

// src/devcenter-app-instance-v1-app-instance-app-instances.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressMarketAimApiAppInstanceServiceUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/app-instance-manager-webapp",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "dev._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      },
      {
        srcPath: "/api/v1/instance",
        destPath: "/v1/instance"
      },
      {
        srcPath: "/api/v1/scripts",
        destPath: "/v1/scripts"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_app-management_app-instances";
function getAppInstance(payload) {
  function __getAppInstance({ host }) {
    const metadata = {
      entityFqdn: "wix.devcenter.app_instance.v1.app_instance",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.AppInstanceService.GetAppInstance",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiAppInstanceServiceUrl({
        protoPath: "/v1/instance",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "instance.billing.freeTrialInfo.endDate" }]
        }
      ])
    };
    return metadata;
  }
  return __getAppInstance;
}

// src/devcenter-app-instance-v1-app-instance-app-instances.universal.ts
var PaymentCycle = /* @__PURE__ */ ((PaymentCycle2) => {
  PaymentCycle2["NO_CYCLE"] = "NO_CYCLE";
  PaymentCycle2["MONTHLY"] = "MONTHLY";
  PaymentCycle2["YEARLY"] = "YEARLY";
  PaymentCycle2["ONE_TIME"] = "ONE_TIME";
  PaymentCycle2["TWO_YEARS"] = "TWO_YEARS";
  PaymentCycle2["THREE_YEARS"] = "THREE_YEARS";
  PaymentCycle2["FOUR_YEARS"] = "FOUR_YEARS";
  PaymentCycle2["FIVE_YEARS"] = "FIVE_YEARS";
  return PaymentCycle2;
})(PaymentCycle || {});
var FreeTrialStatus = /* @__PURE__ */ ((FreeTrialStatus2) => {
  FreeTrialStatus2["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
  FreeTrialStatus2["IN_PROGRESS"] = "IN_PROGRESS";
  FreeTrialStatus2["ENDED"] = "ENDED";
  FreeTrialStatus2["NOT_AVAILABLE"] = "NOT_AVAILABLE";
  return FreeTrialStatus2;
})(FreeTrialStatus || {});
var FreeTrialPeriod = /* @__PURE__ */ ((FreeTrialPeriod2) => {
  FreeTrialPeriod2["FREE_TRIAL_PERIOD_UNKNOWN"] = "FREE_TRIAL_PERIOD_UNKNOWN";
  FreeTrialPeriod2["DURING_FREE_TRIAL"] = "DURING_FREE_TRIAL";
  FreeTrialPeriod2["NOT_DURING_FREE_TRIAL"] = "NOT_DURING_FREE_TRIAL";
  return FreeTrialPeriod2;
})(FreeTrialPeriod || {});
var ReactivationReason = /* @__PURE__ */ ((ReactivationReason2) => {
  ReactivationReason2["REACTIVATION_REASON_UNKNOWN"] = "REACTIVATION_REASON_UNKNOWN";
  ReactivationReason2["AUTO_RENEW_TURNED_ON"] = "AUTO_RENEW_TURNED_ON";
  return ReactivationReason2;
})(ReactivationReason || {});
var ResolutionMethod = /* @__PURE__ */ ((ResolutionMethod2) => {
  ResolutionMethod2["QUERY_PARAM"] = "QUERY_PARAM";
  ResolutionMethod2["SUBDOMAIN"] = "SUBDOMAIN";
  ResolutionMethod2["SUBDIRECTORY"] = "SUBDIRECTORY";
  return ResolutionMethod2;
})(ResolutionMethod || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function getAppInstance2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = renameKeysFromSDKRequestToRESTRequest({});
  const reqOpts = getAppInstance(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/devcenter-app-instance-v1-app-instance-app-instances.public.ts
function getAppInstance3(httpClient) {
  return () => getAppInstance2(
    // @ts-ignore
    { httpClient }
  );
}
var onAppInstanceInstalled = EventDefinition(
  "AppInstalled",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(event)
)();
var onAppInstanceRemoved = EventDefinition(
  "AppRemoved",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(event)
)();
var onAppInstancePaidPlanAutoRenewalCancelled = EventDefinition(
  "PaidPlanAutoRenewalCancelled",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(
    transformPaths2(event, [
      {
        transformFn: transformRESTTimestampToSDKTimestamp2,
        paths: [{ path: "data.operationTimeStamp" }]
      }
    ])
  )
)();
var onAppInstancePaidPlanChanged = EventDefinition(
  "PaidPlanChanged",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(
    transformPaths2(event, [
      {
        transformFn: transformRESTTimestampToSDKTimestamp2,
        paths: [{ path: "data.operationTimeStamp" }]
      }
    ])
  )
)();
var onAppInstancePaidPlanPurchased = EventDefinition(
  "PaidPlanPurchased",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(
    transformPaths2(event, [
      {
        transformFn: transformRESTTimestampToSDKTimestamp2,
        paths: [
          { path: "data.operationTimeStamp" },
          { path: "data.expiresOn" }
        ]
      }
    ])
  )
)();
var onAppInstancePlanConvertedToPaid = EventDefinition(
  "PlanConvertedToPaid",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(
    transformPaths2(event, [
      {
        transformFn: transformRESTTimestampToSDKTimestamp2,
        paths: [
          { path: "data.operationTimeStamp" },
          { path: "data.expiresOn" }
        ]
      }
    ])
  )
)();
var onAppInstancePlanReactivated = EventDefinition(
  "PlanReactivated",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(
    transformPaths2(event, [
      {
        transformFn: transformRESTTimestampToSDKTimestamp2,
        paths: [
          { path: "data.operationTimeStamp" },
          { path: "data.expiresOn" }
        ]
      }
    ])
  )
)();
var onAppInstancePlanTransferred = EventDefinition(
  "PlanTransferred",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(
    transformPaths2(event, [
      {
        transformFn: transformRESTTimestampToSDKTimestamp2,
        paths: [{ path: "data.operationTimeStamp" }]
      }
    ])
  )
)();

// src/devcenter-app-instance-v1-app-instance-app-instances.context.ts
import { createRESTModule } from "@wix/sdk-runtime/rest-modules";
import { createEventModule } from "@wix/sdk-runtime/event-definition-modules";
var getAppInstance4 = /* @__PURE__ */ createRESTModule(getAppInstance3);
var onAppInstanceInstalled2 = createEventModule(onAppInstanceInstalled);
var onAppInstanceRemoved2 = createEventModule(onAppInstanceRemoved);
var onAppInstancePaidPlanAutoRenewalCancelled2 = createEventModule(onAppInstancePaidPlanAutoRenewalCancelled);
var onAppInstancePaidPlanChanged2 = createEventModule(onAppInstancePaidPlanChanged);
var onAppInstancePaidPlanPurchased2 = createEventModule(onAppInstancePaidPlanPurchased);
var onAppInstancePlanConvertedToPaid2 = createEventModule(onAppInstancePlanConvertedToPaid);
var onAppInstancePlanReactivated2 = createEventModule(onAppInstancePlanReactivated);
var onAppInstancePlanTransferred2 = createEventModule(onAppInstancePlanTransferred);
export {
  FreeTrialPeriod,
  FreeTrialStatus,
  PaymentCycle,
  ReactivationReason,
  ResolutionMethod,
  WebhookIdentityType,
  getAppInstance4 as getAppInstance,
  onAppInstanceInstalled2 as onAppInstanceInstalled,
  onAppInstancePaidPlanAutoRenewalCancelled2 as onAppInstancePaidPlanAutoRenewalCancelled,
  onAppInstancePaidPlanChanged2 as onAppInstancePaidPlanChanged,
  onAppInstancePaidPlanPurchased2 as onAppInstancePaidPlanPurchased,
  onAppInstancePlanConvertedToPaid2 as onAppInstancePlanConvertedToPaid,
  onAppInstancePlanReactivated2 as onAppInstancePlanReactivated,
  onAppInstancePlanTransferred2 as onAppInstancePlanTransferred,
  onAppInstanceRemoved2 as onAppInstanceRemoved
};
//# sourceMappingURL=index.mjs.map