"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var index_exports = {};
__export(index_exports, {
  FreeTrialPeriod: () => FreeTrialPeriod,
  FreeTrialStatus: () => FreeTrialStatus,
  PaymentCycle: () => PaymentCycle,
  ReactivationReason: () => ReactivationReason,
  ResolutionMethod: () => ResolutionMethod,
  WebhookIdentityType: () => WebhookIdentityType,
  getAppInstance: () => getAppInstance4,
  onAppInstanceInstalled: () => onAppInstanceInstalled2,
  onAppInstancePaidPlanAutoRenewalCancelled: () => onAppInstancePaidPlanAutoRenewalCancelled2,
  onAppInstancePaidPlanChanged: () => onAppInstancePaidPlanChanged2,
  onAppInstancePaidPlanPurchased: () => onAppInstancePaidPlanPurchased2,
  onAppInstancePlanConvertedToPaid: () => onAppInstancePlanConvertedToPaid2,
  onAppInstancePlanReactivated: () => onAppInstancePlanReactivated2,
  onAppInstancePlanTransferred: () => onAppInstancePlanTransferred2,
  onAppInstanceRemoved: () => onAppInstanceRemoved2
});
module.exports = __toCommonJS(index_exports);

// src/devcenter-app-instance-v1-app-instance-app-instances.public.ts
var import_rename_all_nested_keys2 = require("@wix/sdk-runtime/rename-all-nested-keys");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths2 = require("@wix/sdk-runtime/transformations/transform-paths");
var import_sdk_types = require("@wix/sdk-types");

// src/devcenter-app-instance-v1-app-instance-app-instances.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/devcenter-app-instance-v1-app-instance-app-instances.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressMarketAimApiAppInstanceServiceUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/app-instance-manager-webapp",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "dev._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      },
      {
        srcPath: "/api/v1/instance",
        destPath: "/v1/instance"
      },
      {
        srcPath: "/api/v1/scripts",
        destPath: "/v1/scripts"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_app-management_app-instances";
function getAppInstance(payload) {
  function __getAppInstance({ host }) {
    const metadata = {
      entityFqdn: "wix.devcenter.app_instance.v1.app_instance",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.AppInstanceService.GetAppInstance",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiAppInstanceServiceUrl({
        protoPath: "/v1/instance",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp.transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "instance.billing.freeTrialInfo.endDate" }]
        }
      ])
    };
    return metadata;
  }
  return __getAppInstance;
}

// src/devcenter-app-instance-v1-app-instance-app-instances.universal.ts
var PaymentCycle = /* @__PURE__ */ ((PaymentCycle2) => {
  PaymentCycle2["NO_CYCLE"] = "NO_CYCLE";
  PaymentCycle2["MONTHLY"] = "MONTHLY";
  PaymentCycle2["YEARLY"] = "YEARLY";
  PaymentCycle2["ONE_TIME"] = "ONE_TIME";
  PaymentCycle2["TWO_YEARS"] = "TWO_YEARS";
  PaymentCycle2["THREE_YEARS"] = "THREE_YEARS";
  PaymentCycle2["FOUR_YEARS"] = "FOUR_YEARS";
  PaymentCycle2["FIVE_YEARS"] = "FIVE_YEARS";
  return PaymentCycle2;
})(PaymentCycle || {});
var FreeTrialStatus = /* @__PURE__ */ ((FreeTrialStatus2) => {
  FreeTrialStatus2["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
  FreeTrialStatus2["IN_PROGRESS"] = "IN_PROGRESS";
  FreeTrialStatus2["ENDED"] = "ENDED";
  FreeTrialStatus2["NOT_AVAILABLE"] = "NOT_AVAILABLE";
  return FreeTrialStatus2;
})(FreeTrialStatus || {});
var FreeTrialPeriod = /* @__PURE__ */ ((FreeTrialPeriod2) => {
  FreeTrialPeriod2["FREE_TRIAL_PERIOD_UNKNOWN"] = "FREE_TRIAL_PERIOD_UNKNOWN";
  FreeTrialPeriod2["DURING_FREE_TRIAL"] = "DURING_FREE_TRIAL";
  FreeTrialPeriod2["NOT_DURING_FREE_TRIAL"] = "NOT_DURING_FREE_TRIAL";
  return FreeTrialPeriod2;
})(FreeTrialPeriod || {});
var ReactivationReason = /* @__PURE__ */ ((ReactivationReason2) => {
  ReactivationReason2["REACTIVATION_REASON_UNKNOWN"] = "REACTIVATION_REASON_UNKNOWN";
  ReactivationReason2["AUTO_RENEW_TURNED_ON"] = "AUTO_RENEW_TURNED_ON";
  return ReactivationReason2;
})(ReactivationReason || {});
var ResolutionMethod = /* @__PURE__ */ ((ResolutionMethod2) => {
  ResolutionMethod2["QUERY_PARAM"] = "QUERY_PARAM";
  ResolutionMethod2["SUBDOMAIN"] = "SUBDOMAIN";
  ResolutionMethod2["SUBDIRECTORY"] = "SUBDIRECTORY";
  return ResolutionMethod2;
})(ResolutionMethod || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function getAppInstance2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({});
  const reqOpts = getAppInstance(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/devcenter-app-instance-v1-app-instance-app-instances.public.ts
function getAppInstance3(httpClient) {
  return () => getAppInstance2(
    // @ts-ignore
    { httpClient }
  );
}
var onAppInstanceInstalled = (0, import_sdk_types.EventDefinition)(
  "AppInstalled",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(event)
)();
var onAppInstanceRemoved = (0, import_sdk_types.EventDefinition)(
  "AppRemoved",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(event)
)();
var onAppInstancePaidPlanAutoRenewalCancelled = (0, import_sdk_types.EventDefinition)(
  "PaidPlanAutoRenewalCancelled",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths2.transformPaths)(event, [
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: "data.operationTimeStamp" }]
      }
    ])
  )
)();
var onAppInstancePaidPlanChanged = (0, import_sdk_types.EventDefinition)(
  "PaidPlanChanged",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths2.transformPaths)(event, [
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: "data.operationTimeStamp" }]
      }
    ])
  )
)();
var onAppInstancePaidPlanPurchased = (0, import_sdk_types.EventDefinition)(
  "PaidPlanPurchased",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths2.transformPaths)(event, [
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [
          { path: "data.operationTimeStamp" },
          { path: "data.expiresOn" }
        ]
      }
    ])
  )
)();
var onAppInstancePlanConvertedToPaid = (0, import_sdk_types.EventDefinition)(
  "PlanConvertedToPaid",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths2.transformPaths)(event, [
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [
          { path: "data.operationTimeStamp" },
          { path: "data.expiresOn" }
        ]
      }
    ])
  )
)();
var onAppInstancePlanReactivated = (0, import_sdk_types.EventDefinition)(
  "PlanReactivated",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths2.transformPaths)(event, [
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [
          { path: "data.operationTimeStamp" },
          { path: "data.expiresOn" }
        ]
      }
    ])
  )
)();
var onAppInstancePlanTransferred = (0, import_sdk_types.EventDefinition)(
  "PlanTransferred",
  false,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths2.transformPaths)(event, [
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: "data.operationTimeStamp" }]
      }
    ])
  )
)();

// src/devcenter-app-instance-v1-app-instance-app-instances.context.ts
var import_rest_modules3 = require("@wix/sdk-runtime/rest-modules");
var import_event_definition_modules = require("@wix/sdk-runtime/event-definition-modules");
var getAppInstance4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(getAppInstance3);
var onAppInstanceInstalled2 = (0, import_event_definition_modules.createEventModule)(onAppInstanceInstalled);
var onAppInstanceRemoved2 = (0, import_event_definition_modules.createEventModule)(onAppInstanceRemoved);
var onAppInstancePaidPlanAutoRenewalCancelled2 = (0, import_event_definition_modules.createEventModule)(onAppInstancePaidPlanAutoRenewalCancelled);
var onAppInstancePaidPlanChanged2 = (0, import_event_definition_modules.createEventModule)(onAppInstancePaidPlanChanged);
var onAppInstancePaidPlanPurchased2 = (0, import_event_definition_modules.createEventModule)(onAppInstancePaidPlanPurchased);
var onAppInstancePlanConvertedToPaid2 = (0, import_event_definition_modules.createEventModule)(onAppInstancePlanConvertedToPaid);
var onAppInstancePlanReactivated2 = (0, import_event_definition_modules.createEventModule)(onAppInstancePlanReactivated);
var onAppInstancePlanTransferred2 = (0, import_event_definition_modules.createEventModule)(onAppInstancePlanTransferred);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FreeTrialPeriod,
  FreeTrialStatus,
  PaymentCycle,
  ReactivationReason,
  ResolutionMethod,
  WebhookIdentityType,
  getAppInstance,
  onAppInstanceInstalled,
  onAppInstancePaidPlanAutoRenewalCancelled,
  onAppInstancePaidPlanChanged,
  onAppInstancePaidPlanPurchased,
  onAppInstancePlanConvertedToPaid,
  onAppInstancePlanReactivated,
  onAppInstancePlanTransferred,
  onAppInstanceRemoved
});
//# sourceMappingURL=index.js.map